/*
 * him-arabic.hh
 * This file is part of him-arabic
 *
 * Copyright (C) 2007 Mohammed Sameer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __HIM_ARABIC_HH__
#define __HIM_ARABIC_HH__

#include <hildon-im-plugin.h>
#include <hildon-im-ui.h>
#include "plugin.hh"

extern "C" void him_arabic_enable(HildonIMPlugin *, gboolean);
extern "C" void him_arabic_disable(HildonIMPlugin *);
extern "C" void him_arabic_enter(HildonIMPlugin *);
extern "C" void him_arabic_tab(HildonIMPlugin *);
extern "C" void him_arabic_backspace(HildonIMPlugin *);
extern "C" void him_arabic_clear(HildonIMPlugin *);
extern "C" void him_arabic_input_mode_changed(HildonIMPlugin *);
extern "C" void him_arabic_client_widget_changed(HildonIMPlugin *);
extern "C" void him_arabic_save_data(HildonIMPlugin *);
extern "C" void him_arabic_language(HildonIMPlugin *);
extern "C" void him_arabic_mode_a(HildonIMPlugin *);
extern "C" void him_arabic_mode_b(HildonIMPlugin *);
extern "C" void him_arabic_language_settings_changed(HildonIMPlugin *, gint);
extern "C" void him_arabic_settings_changed(HildonIMPlugin *, const gchar *, const GConfValue *);

void him_arabic_signal_error(HimArabic *, const std::string&);
void him_arabic_reset_layouts(HimArabic *, gchar * = NULL);

#endif /* __HIM_ARABIC_HH__ */
