/*
 * plugin.hh
 * This file is part of him-arabic
 *
 * Copyright (C) 2007 Mohammed Sameer
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef __PLUGIN_HH__
#define __PLUGIN_HH__

#include <hildon-im-plugin.h>
#include <hildon-im-ui.h>
#include <gtk/gtkvbox.h>
#include <gtk/gtkhbox.h>
#include <vector>
#include <map>
#include "data.hh"

/* GType crap */
typedef struct {
  GtkVBox parent;
  std::map<std::string, std::map<LayoutType, GtkWidget *> > *layouts;
  bool mode_a;
  bool mode_b;
  GtkWidget *current;
	   //  std::vector<GtkWidget *> rows;
    //  std::vector<GtkButton *> buttons;
  //  GtkWidget *one, *two, *three, *four;
  //  GtkButton *buttons[];
} HimArabic;

typedef struct {
  GtkVBoxClass parent;
} HimArabicClass;

typedef struct {
  HildonIMUI *ui;
} HimArabicPriv;

extern "C" void module_init (GTypeModule *);
extern "C" void module_exit();
extern "C" HildonIMPlugin* module_create(HildonIMUI *);

GType him_arabic_get_type();

#define HIM_ARABIC_TYPE (him_arabic_get_type())
#define HIM_ARABIC_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), HIM_ARABIC_TYPE, HimArabicPriv))
#define IS_HIM_ARABIC(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), HIM_ARABIC_TYPE))
#define HIM_ARABIC(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), HIM_ARABIC_TYPE, HimArabic))
#define HIM_ARABIC_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), HIM_ARABIC_TYPE, HimArabicClass))
#define IS_HIM_ARABIC_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), HIM_ARABIC_TYPE))
#define HIM_ARABIC_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), HIM_ARABIC_TYPE, HimArabicClass))

/* plugin info */
extern "C" const HildonIMPluginInfo* hildon_im_plugin_get_info();
extern "C" gchar** hildon_im_plugin_get_available_languages(gboolean *);

void him_arabic_activate_layout(HimArabic *, std::map<LayoutType, GtkWidget *>&);
void him_arabic_draw_layout(HimArabic *, const LayoutType&, std::vector<std::vector<Key> >&, const std::string&);

#endif /* __PLUGIN_HH__ */
